angular.module('beamng.apps')

.directive('traffic', ['bngApi', function (bngApi) {
	return {
		templateUrl: 'modules/apps/traffic/app.html',
		replace: false,
		restrict: 'E',
		scope: false,
		controller: function ($scope, $element, $attrs) {
			$scope.checkImg = "url(modules/apps/traffic/checkmark.png)";
			$scope.mainStyle = {appWidth: "100%", appHeight: "100%", inLeft: "auto", inRight: "0px", appShow: "visible", optionsShow: "hidden"};
			$scope.visible = {main: true};
			$scope.inText = "-";
			$scope.unit = "КМ/Ч";
			$scope.convert = [2.2369, 3.6];
			$scope.metric = true;
			$scope.quantity = 1;
			$scope.speedLimit = 60;
			$scope.spawnIn = 1;
			$scope.spawnOut = 1;
			
			$scope.aiModeOptions = ["Нормальный", "Убегать", "Догонять", "Стоп"];
			$scope.debugOptions = ["Выключить", "Цель", "Скорости", "Траектория", "Маршрут"];
			
			this.toggleAll = function() {
				$scope.visible.main = !$scope.visible.main;
				if($scope.visible.main == false) {
					$scope.mainStyle = {appWidth: "16px", appHeight: "16px", inLeft: "0px", inRight: "auto", appShow: "hidden", optionsShow: "hidden"};
					$scope.inText = "+";
				} else {
					$scope.mainStyle = {appWidth: "100%", appHeight: "100%", inLeft: "auto", inRight: "0px", appShow: "visible", optionsShow: "hidden"};
					$scope.inText = "-";
				}
			}
			
			this.showOptions = function() {
				$scope.mainStyle.optionsShow = "visible";
			}
			
			this.setAiMode = function() {
				var total = $scope.aiModeOptions.length - 1;
				for(var i = 0; i <= total; i++) {
					if (this.aiModeOptions == $scope.aiModeOptions[i]) {
						i++;
						var command = `extensions.core_multiSpawn.setAiMode(` + i + `)`;
						bngApi.engineLua(command);
					}
				}
			}	
			
			this.setDebugMode = function() {
				var total = $scope.debugOptions.length - 1;
				for(var i = 0; i <= total; i++) {
					if (this.debugOptions == $scope.debugOptions[i]) {
						i++;
						var command = `extensions.core_multiSpawn.setDebugMode(` + i + `)`;
						bngApi.engineLua(command);
					}
				}
			}	
			
			this.setSpeedLimit = function() {
				var m = Number($scope.metric);
				var n = this.speedLimit / $scope.convert[m];
				var command = `extensions.core_multiSpawn.setSpeedLimit(` + n + `)`;
				bngApi.engineLua(command);
			}
			
			this.toggleUnits = function() {
				$scope.metric = !$scope.metric;
				if($scope.metric == false) {
					$scope.unit = "М/Ч";
				} else {
					$scope.unit = "КМ/Ч";
				}
				this.setSpeedLimit();
			}
			
			this.setQuantity = function() {
				var command = `extensions.core_multiSpawn.setQuantity(${this.quantity})`;
				bngApi.engineLua(command);
			}
			
			this.setSpawnIn = function() {
				var command = `extensions.core_multiSpawn.setSpawnIn(${this.spawnIn})`;
				bngApi.engineLua(command);
			}
			
			this.setSpawnOut = function() {
				var command = `extensions.core_multiSpawn.setSpawnOut(${this.spawnOut})`;
				bngApi.engineLua(command);
			}
			
			this.spawn = function() {
				var command = `extensions.core_multiSpawn.setupVehicles()`;
				bngApi.engineLua(command);
			}
			
			this.delete = function() {
				var command = `extensions.core_multiSpawn.deleteVehicles()`;
				bngApi.engineLua(command);
			}
			
			this.activate = function() {
				var command = `extensions.core_multiSpawn.startTraffic()`;
				bngApi.engineLua(command);
			}
			
			this.deactivate = function() {
				var command = `extensions.core_multiSpawn.stopTraffic()`;
				bngApi.engineLua(command);
			}
			
			this.refresh = function() {
				var command = `extensions.core_multiSpawn.refreshVehicles()`;
				bngApi.engineLua(command);
			}
			
		},
		controllerAs: 'ctrl'
	};
}]);